using System;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;

public class FileHandler
{
    public bool LoadAudioConfiguration()
    {
        if (!File.Exists("AudioConfig.cfg"))
        {
            return false;
        }
        string[] strArray = File.ReadAllLines("AudioConfig.cfg");
        if (strArray.Length != 2)
        {
            return false;
        }
        GlobalDefs.OutputAudio.description = strArray[0];
        string g = strArray[1];
        string[] strArray2 = g.Split(new char[] { '-' });
        if ((((strArray2.Length != 5) || (strArray2[0].Length != 8)) || ((strArray2[1].Length != 4) || (strArray2[2].Length != 4))) || ((strArray2[3].Length != 4) || (strArray2[4].Length != 12)))
        {
            return false;
        }
        GlobalDefs.OutputAudio.AudioGuid = new Guid(g);
        return true;
    }

    public bool LoadFile()
    {
        GlobalDefs.bFirstRun = this.LoadStatsConfiguration();
        return this.LoadPadConfigurations();
    }

    public bool LoadGraphicsConfiguration()
    {
        if (!File.Exists("GraphicsConfig.cfg"))
        {
            return false;
        }
        string[] strArray = File.ReadAllLines("GraphicsConfig.cfg");
        if (strArray.Length != 12)
        {
            return false;
        }
        GlobalDefs.OutputAdapter.AdapterDescription = strArray[1];
        GlobalDefs.OutputAdapter.AdapterName = strArray[2];
        string[] strArray2 = strArray[3].Split(new char[] { '.' });
        Regex regex = new Regex("[^0-9]");
        GlobalDefs.OutputAdapter.OutputRes.Width = Convert.ToInt32(regex.Replace(strArray2[0], string.Empty));
        GlobalDefs.OutputAdapter.OutputRes.Height = Convert.ToInt32(regex.Replace(strArray2[1], string.Empty));
        GlobalDefs.OutputAdapter.OutputRes.Refresh = Convert.ToInt32(regex.Replace(strArray2[2], string.Empty));
        GlobalDefs.OutputAdapter.AA = Convert.ToInt32(regex.Replace(strArray[4], string.Empty));
        Regex regex2 = new Regex("[^0-1]");
        GlobalDefs.OutputAdapter.bVSync = regex2.Replace(strArray[5], string.Empty) == "1";
        GlobalDefs.OutputAdapter.ShadQuality = regex2.Replace(strArray[6], string.Empty) == "1";
        GlobalDefs.OutputAdapter.ReflectQuality = regex2.Replace(strArray[7], string.Empty) == "1";
        GlobalDefs.OutputAdapter.DisplayMode = regex2.Replace(strArray[8], string.Empty) == "1";
        string g = strArray[9];
        string[] strArray3 = g.Split(new char[] { '-' });
        if ((((strArray3.Length != 5) || (strArray3[0].Length != 8)) || ((strArray3[1].Length != 4) || (strArray3[2].Length != 4))) || ((strArray3[3].Length != 4) || (strArray3[4].Length != 12)))
        {
            return false;
        }
        GlobalDefs.OutputAdapter.DeviceGUID = new Guid(g);
        GlobalDefs.OutputAdapter.AdapterID = strArray[10];
        GlobalDefs.OutputAdapter.DepthFormat = Convert.ToUInt32(regex.Replace(strArray[11], string.Empty));
        GlobalDefs.OutputAdapter.bWindowed = false;
        GlobalDefs.OutputAdapter.ValidAdapter = true;
        return true;
    }

    public bool LoadGraphicsFile()
    {
        GlobalDefs.GraphicsConfigFileRead = this.LoadGraphicsConfiguration();
        return true;
    }

    public bool LoadInfoConfig(string ConfigFileName, int PadIndex)
    {
        string[] strArray = File.ReadAllLines(ConfigFileName);
        List<string> list = new List<string>();
        List<string> list2 = new List<string>();
        List<string> list3 = new List<string>();
        List<string> list4 = new List<string>();
        List<string> list5 = new List<string>();
        for (int i = 0; i < strArray.Length; i++)
        {
            string item = "";
            string str2 = "";
            string str3 = "";
            string str4 = "";
            string str5 = "";
            string[] strArray2 = strArray[i].Split(new char[] { '$' });
            for (int k = 0; k < strArray2.Length; k++)
            {
                if (strArray2[k].StartsWith("G:"))
                {
                    string input = strArray2[k].Remove(0, 2);
                    Regex regex = new Regex(@"[^0-9, ,\-,^a-z,^A-Z]");
                    str2 = str2 + regex.Replace(input, string.Empty);
                }
                else if (strArray2[k].StartsWith("B:"))
                {
                    Regex regex2 = new Regex("[^0-9, ]");
                    str3 = str3 + regex2.Replace(strArray2[k], string.Empty);
                }
                else if (strArray2[k].StartsWith("A:"))
                {
                    Regex regex3 = new Regex("[^0-9, ]");
                    str4 = str4 + regex3.Replace(strArray2[k], string.Empty);
                }
                else if (strArray2[k].StartsWith("D:"))
                {
                    Regex regex4 = new Regex("[^0-9, ]");
                    str5 = str5 + regex4.Replace(strArray2[k], string.Empty);
                }
                else
                {
                    item = item + strArray2[k];
                }
            }
            item = item.TrimStart(new char[] { ' ' }).TrimEnd(new char[] { ' ' });
            str2 = str2.TrimStart(new char[] { ' ' }).TrimEnd(new char[] { ' ' });
            if (item != "")
            {
                list.Add(item);
            }
            if (str2 != "")
            {
                list2.Add(str2);
            }
            if (str3 != "")
            {
                list3.Add(str3);
            }
            if (str4 != "")
            {
                list4.Add(str4);
            }
            if (str5 != "")
            {
                list5.Add(str5);
            }
        }
        for (int j = 0; j < list2.Count; j++)
        {
            string[] strArray3 = list2[j].Split(new char[] { '-' });
            if ((((strArray3.Length != 5) || (strArray3[0].Length != 8)) || ((strArray3[1].Length != 4) || (strArray3[2].Length != 4))) || ((strArray3[3].Length != 4) || (strArray3[4].Length != 12)))
            {
                list2.Remove(list2[j]);
                list.Remove(list[j]);
                list3.Remove(list3[j]);
                list4.Remove(list4[j]);
                list5.Remove(list5[j]);
            }
        }
        int num4 = 0;
        int[] numArray = new int[0x12];
        int[] numArray2 = new int[4];
        int num5 = 0;
        byte num6 = 0;
        foreach (string str7 in list2)
        {
            string[] strArray4 = list3[num4].Split(new char[] { ' ' });
            int index = 0;
            while ((index < strArray4.Length) && (index < 0x12))
            {
                if (strArray4[index] != "")
                {
                    numArray[index] = Convert.ToInt32(strArray4[index]);
                }
                else
                {
                    numArray[index] = 0;
                }
                index++;
            }
            while (index < 0x12)
            {
                numArray[index] = 0;
                index++;
            }
            int num8 = strArray4.Length - 1;
            while ((strArray4[num8] == "") && (num8 >= 0))
            {
                num8--;
            }
            num6 = Convert.ToByte(strArray4[num8]);
            string[] strArray5 = list4[num4].Split(new char[] { ' ' });
            index = 0;
            while ((index < strArray5.Length) && (index < 4))
            {
                if (strArray5[index] != "")
                {
                    numArray2[index] = Convert.ToInt32(strArray5[index]);
                }
                else
                {
                    numArray2[index] = 0;
                }
                index++;
            }
            while (index < 4)
            {
                numArray2[index] = 0;
                index++;
            }
            if (list5[num4] != "")
            {
                num5 = Convert.ToInt32(list5[num4]);
            }
            else
            {
                num5 = 0;
            }
            bool flag = false;
            if (PadIndex < 0)
            {
                foreach (OutputConfig config in GlobalDefs.OutputConfigList)
                {
                    Guid guid = new Guid("00000000-0000-0000-0000-000000000000");
                    if (str7 == guid.ToString())
                    {
                        flag = true;
                        break;
                    }
                    if (str7 == config.mProductGuid.ToString())
                    {
                        numArray.CopyTo(config.mButtonMap, 0);
                        numArray2.CopyTo(config.mAxisMap, 0);
                        config.mDeadZone = num5;
                        config.mMovementType = num6;
                        flag = true;
                        break;
                    }
                }
                if (!flag)
                {
                    OutputConfig config2 = new OutputConfig();
                    config2.mProductGuid = new Guid(str7);
                    config2.mProductName = list[num4];
                    numArray.CopyTo(config2.mButtonMap, 0);
                    numArray2.CopyTo(config2.mAxisMap, 0);
                    config2.mDeadZone = num5;
                    config2.mMovementType = num6;
                    GlobalDefs.OutputConfigList.Add(config2);
                }
            }
            else if (PadIndex < GlobalDefs.OutputConfigList.Count)
            {
                if (str7 == GlobalDefs.OutputConfigList[PadIndex].mProductGuid.ToString())
                {
                    numArray.CopyTo(GlobalDefs.OutputConfigList[PadIndex].mButtonMap, 0);
                    numArray2.CopyTo(GlobalDefs.OutputConfigList[PadIndex].mAxisMap, 0);
                    GlobalDefs.OutputConfigList[PadIndex].mDeadZone = num5;
                    GlobalDefs.OutputConfigList[PadIndex].mMovementType = num6;
                    return true;
                }
            }
            else
            {
                return false;
            }
            num4++;
        }
        return (PadIndex == -1);
    }

    public bool LoadPadConfigurations()
    {
        RegistryData data = new RegistryData();
        string path = "DefaultInput.cfg";
        string str2 = data.ReadSaveLocationFromRegistry + @"\PlayerInput.cfg";
        try
        {
            if (File.Exists(path))
            {
                this.LoadInfoConfig(path, -1);
            }
            if (File.Exists(str2))
            {
                this.LoadInfoConfig(str2, -1);
            }
        }
        catch (Exception)
        {
            return false;
        }
        return true;
    }

    public bool LoadStatsConfiguration()
    {
        if (!File.Exists("StatsConfig.cfg"))
        {
            return false;
        }
        string[] strArray = File.ReadAllLines("StatsConfig.cfg");
        if (strArray.Length != 1)
        {
            return false;
        }
        GlobalDefs.AnalyticsEnabled = Convert.ToInt32(strArray[0]) == 1;
        return true;
    }

    private bool PopulateAdapterList()
    {
        return true;
    }

    public bool SaveAudioConfiguration()
    {
        string path = "AudioConfig.cfg";
        List<string> list = new List<string>();
        list.Add(GlobalDefs.OutputAudio.description);
        list.Add(GlobalDefs.OutputAudio.AudioGuid.ToString());
        File.WriteAllLines(path, list.ToArray());
        return true;
    }

    public bool SaveFile()
    {
        this.SavePadConfigurations();
        this.SaveGraphicsConfiguration();
        this.SaveAudioConfiguration();
        this.SaveStatsConfiguration();
        return true;
    }

    private bool SaveGraphicsConfiguration()
    {
        string path = "GraphicsConfig.cfg";
        List<string> list = new List<string>();
        if (GlobalDefs.OutputAdapter.ValidAdapter)
        {
            list.Add("Do not manually edit this file, use the configuration tool.");
            list.Add(GlobalDefs.OutputAdapter.AdapterDescription);
            list.Add(GlobalDefs.OutputAdapter.AdapterName);
            list.Add(GlobalDefs.OutputAdapter.OutputRes.ToString());
            list.Add(GlobalDefs.OutputAdapter.AA.ToString());
            list.Add((GlobalDefs.OutputAdapter.bVSync ? 1 : 0).ToString());
            list.Add((GlobalDefs.OutputAdapter.ShadQuality ? 1 : 0).ToString());
            list.Add((GlobalDefs.OutputAdapter.ReflectQuality ? 1 : 0).ToString());
            list.Add((GlobalDefs.OutputAdapter.DisplayMode ? 1 : 0).ToString());
            list.Add(GlobalDefs.OutputAdapter.DeviceGUID.ToString());
            list.Add(GlobalDefs.OutputAdapter.AdapterID);
            list.Add(GlobalDefs.OutputAdapter.DepthFormat.ToString());
        }
        else
        {
            list.Add("No Valid Graphics Adapter");
        }
        File.WriteAllLines(path, list.ToArray());
        return true;
    }

    private bool SavePadConfigurations()
    {
        RegistryData data = new RegistryData();
        string readSaveLocationFromRegistry = data.ReadSaveLocationFromRegistry;
        if (readSaveLocationFromRegistry == "")
        {
            return false;
        }
        if (!File.Exists(readSaveLocationFromRegistry))
        {
            Directory.CreateDirectory(readSaveLocationFromRegistry);
        }
        readSaveLocationFromRegistry = readSaveLocationFromRegistry + @"\PlayerInput.cfg";
        List<string> list = new List<string>();
        GlobalDefs defs = new GlobalDefs();
        foreach (OutputConfig config in GlobalDefs.OutputConfigList)
        {
            if (config.mProductGuid != defs.ZERO_GUID)
            {
                list.Add(config.mProductName.ToString());
                string item = "$G:";
                item = item + config.mProductGuid.ToString();
                string str3 = "";
                for (int i = 0; i < config.mButtonMap.Length; i++)
                {
                    str3 = str3 + config.mButtonMap[i].ToString() + " ";
                }
                str3 = str3 + config.mMovementType;
                item = item + "$B:" + str3;
                string str4 = "";
                for (int j = 0; j < config.mAxisMap.Length; j++)
                {
                    str4 = str4 + config.mAxisMap[j].ToString() + " ";
                }
                item = ((item + "$A:") + str4 + "$D:") + config.mDeadZone.ToString() + "$";
                list.Add(item);
            }
        }
        File.WriteAllLines(readSaveLocationFromRegistry, list.ToArray());
        return true;
    }

    private bool SaveStatsConfiguration()
    {
        string path = "StatsConfig.cfg";
        string contents = (GlobalDefs.AnalyticsEnabled ? 1 : 0).ToString();
        File.WriteAllText(path, contents);
        return true;
    }

    [Flags]
    private enum ReadingConfigFlags
    {
        RC_Axis = 8,
        RC_Button = 4,
        RC_Dead = 0x16,
        RC_Guid = 2,
        RC_Name = 1,
        RC_None = 0
    }
}
