namespace Generations_Launcher_Front
{
    using Generations_Launcher_Front.TextStore;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Globalization;
    using System.Runtime.InteropServices;
    using System.Threading;
    using System.Windows.Forms;

    public class MainForm : Form
    {
        private Button CancelConfigButton;
        private IContainer components;
        private bool InitExterns;
        private TabPage InputConfig;
        private Button LaunchButton;
        private Button SaveButton;
        private TabPage tabPage1;
        private TabPage tabPage2;
        private TabPage tabPage3;
        private TabControl TabWindow;

        public MainForm()
        {
            this.InitializeComponent();
            this.InitExterns = false;
            this.InitExterns = this.InitializeExternals();
            RegistryData data = new RegistryData();
            Thread.CurrentThread.CurrentUICulture = CultureInfo.GetCultureInfo(data.LCID);
            InputConfiguration configuration = new InputConfiguration();
            this.TabWindow.TabPages[0].Controls.Add(configuration);
            GraphicsConfiguration configuration2 = new GraphicsConfiguration();
            this.TabWindow.TabPages[1].Controls.Add(configuration2);
            StatsConfiguration configuration3 = new StatsConfiguration();
            this.TabWindow.TabPages[2].Controls.Add(configuration3);
            AudioConfiguration configuration4 = new AudioConfiguration();
            this.TabWindow.TabPages[3].Controls.Add(configuration4);
            FileHandler handler = new FileHandler();
            handler.LoadGraphicsFile();
            if (!handler.LoadAudioConfiguration())
            {
                GlobalDefs.OutputAudio.description = "Default";
                GlobalDefs.OutputAudio.AudioGuid = new Guid("FFFFFFFF-FFFF-FFFF-FFFF-FFFFFFFFFFFF");
            }
            this.TabWindow.SelectedIndex = 3;
        }

        private void CancelButton_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.TabWindow = new TabControl();
            this.InputConfig = new TabPage();
            this.tabPage1 = new TabPage();
            this.tabPage2 = new TabPage();
            this.LaunchButton = new Button();
            this.SaveButton = new Button();
            this.CancelConfigButton = new Button();
            this.tabPage3 = new TabPage();
            this.TabWindow.SuspendLayout();
            base.SuspendLayout();
            this.TabWindow.Controls.Add(this.InputConfig);
            this.TabWindow.Controls.Add(this.tabPage1);
            this.TabWindow.Controls.Add(this.tabPage2);
            this.TabWindow.Controls.Add(this.tabPage3);
            this.TabWindow.Location = new Point(12, 12);
            this.TabWindow.Name = "TabWindow";
            this.TabWindow.SelectedIndex = 0;
            this.TabWindow.Size = new Size(0x356, 0x1e6);
            this.TabWindow.TabIndex = 0;
            this.InputConfig.AutoScroll = true;
            this.InputConfig.Location = new Point(4, 0x16);
            this.InputConfig.Name = "InputConfig";
            this.InputConfig.Padding = new Padding(3);
            this.InputConfig.Size = new Size(0x34e, 460);
            this.InputConfig.TabIndex = 0;
            this.InputConfig.Text = "tabPage1";
            this.InputConfig.UseVisualStyleBackColor = true;
            this.tabPage1.Location = new Point(4, 0x16);
            this.tabPage1.Name = "tabPage1";
            this.tabPage1.Padding = new Padding(3);
            this.tabPage1.Size = new Size(0x34e, 460);
            this.tabPage1.TabIndex = 1;
            this.tabPage1.Text = "tabPage1";
            this.tabPage1.UseVisualStyleBackColor = true;
            this.tabPage1.Click += new EventHandler(this.tabPage1_Click);
            this.tabPage2.Location = new Point(4, 0x16);
            this.tabPage2.Name = "tabPage2";
            this.tabPage2.Padding = new Padding(3);
            this.tabPage2.Size = new Size(0x34e, 460);
            this.tabPage2.TabIndex = 2;
            this.tabPage2.Text = "tabPage2";
            this.tabPage2.UseVisualStyleBackColor = true;
            this.tabPage2.Click += new EventHandler(this.tabPage2_Click);
            this.LaunchButton.Location = new Point(0xef, 510);
            this.LaunchButton.Name = "LaunchButton";
            this.LaunchButton.Size = new Size(400, 0x38);
            this.LaunchButton.TabIndex = 1;
            this.LaunchButton.Text = "Save and Quit";
            this.LaunchButton.UseVisualStyleBackColor = true;
            this.LaunchButton.Click += new EventHandler(this.LaunchButton_Click);
            this.SaveButton.Location = new Point(0x10, 510);
            this.SaveButton.Name = "SaveButton";
            this.SaveButton.Size = new Size(0xd9, 0x38);
            this.SaveButton.TabIndex = 2;
            this.SaveButton.Text = "Save";
            this.SaveButton.UseVisualStyleBackColor = true;
            this.SaveButton.Click += new EventHandler(this.SaveButton_Click);
            this.CancelConfigButton.Location = new Point(0x285, 510);
            this.CancelConfigButton.Name = "CancelConfigButton";
            this.CancelConfigButton.Size = new Size(0xd9, 0x38);
            this.CancelConfigButton.TabIndex = 3;
            this.CancelConfigButton.Text = "Cancel";
            this.CancelConfigButton.UseVisualStyleBackColor = true;
            this.CancelConfigButton.Click += new EventHandler(this.CancelButton_Click);
            this.tabPage3.Location = new Point(4, 0x16);
            this.tabPage3.Name = "tabPage3";
            this.tabPage3.Padding = new Padding(3);
            this.tabPage3.Size = new Size(0x34e, 460);
            this.tabPage3.TabIndex = 3;
            this.tabPage3.Text = "tabPage3";
            this.tabPage3.UseVisualStyleBackColor = true;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoScroll = true;
            base.ClientSize = new Size(0x36e, 0x242);
            base.Controls.Add(this.CancelConfigButton);
            base.Controls.Add(this.SaveButton);
            base.Controls.Add(this.LaunchButton);
            base.Controls.Add(this.TabWindow);
            base.Name = "MainForm";
            this.Text = "MainForm";
            base.Load += new EventHandler(this.MainForm_Load);
            this.TabWindow.ResumeLayout(false);
            base.ResumeLayout(false);
        }

        public bool InitializeExternals()
        {
            return true;
            IntPtr hINSTANCE = Marshal.GetHINSTANCE(base.GetType().Module);
            IntPtr handle = base.Handle;
            if (!DllExterns._InitialiseDirectXInput(hINSTANCE, handle))
            {
                return false;
            }
/*            if (!DllExterns._InitialiseDirectX())
            {
                return false;
            }*/
            if (!DllExterns._InitialiseDirectSound())
            {
                return false;
            }
            return true;
        }

        private void LaunchButton_Click(object Sender, EventArgs e)
        {
            new FileHandler().SaveFile();
            Application.Exit();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            if (!this.InitExterns)
            {
                MessageBox.Show(LocalizedText.DXFailed, LocalizedText.CriticalError, MessageBoxButtons.OK, MessageBoxIcon.Hand);
                Application.Exit();
            }
            this.SetFormText();
            new FileHandler().LoadFile();
            this.TabWindow.SelectedIndex = 1;
        }

        private void SaveButton_Click(object sender, EventArgs e)
        {
            new FileHandler().SaveFile();
        }

        public void SetFormText()
        {
            this.Text = LocalizedText.Main_App_Title;
            this.TabWindow.TabPages[0].Text = LocalizedText.InputConfiguration;
            this.TabWindow.TabPages[1].Text = LocalizedText.GraphicsConfiguration;
            this.TabWindow.TabPages[2].Text = LocalizedText.StatsConfiguration;
            this.TabWindow.TabPages[3].Text = LocalizedText.AudioConfiguration;
            this.SaveButton.Text = LocalizedText.Save_Button;
            this.LaunchButton.Text = LocalizedText.SaveQuit_Button;
            this.CancelConfigButton.Text = LocalizedText.Cancel_Button;
        }

        private void tabPage1_Click(object sender, EventArgs e)
        {
        }

        private void tabPage2_Click(object sender, EventArgs e)
        {
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == 0x219)
            {
                IntPtr ptr = new IntPtr(7);
                if (m.WParam == ptr)
                {
                    ((InputConfiguration) this.TabWindow.TabPages[0].Controls[0]).ResetPadListData();
                    ((AudioConfiguration) this.TabWindow.TabPages[3].Controls[0]).ResetAudioListData();
                }
            }
            base.WndProc(ref m);
        }
    }
}
