using System;
using System.Runtime.InteropServices;

[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
public class PadInfo
{
    public PAD_TYPE mPadType = PAD_TYPE.PAD_TYPE_XBOX;
    public int mInstanceID = 0;
    public Guid mProductGuid = new Guid();
    public Guid mInstanceGuid = new Guid();
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst=260)]
    public string mProductName;
    public string DisplayName
    {
        get
        {
            GlobalDefs defs = new GlobalDefs();
            if (!(this.mProductGuid == defs.KEYBOARD_GUID) && !(this.mProductGuid == defs.ZERO_GUID))
            {
                return (this.mProductName + " (#" + this.mInstanceID.ToString() + ")");
            }
            return this.mProductName;
        }
    }
    public enum PAD_TYPE
    {
        PAD_TYPE_KEYBOARD = 2,
        PAD_TYPE_LEGACY = 1,
        PAD_TYPE_NONE = -1,
        PAD_TYPE_XBOX = 0
    }
}
