using System;
using System.Runtime.InteropServices;

[StructLayout(LayoutKind.Sequential)]
public struct Resolution
{
    public int Width;
    public int Height;
    public int Refresh;
    public override string ToString()
    {
        return (this.Width.ToString() + "." + this.Height.ToString() + "." + this.Refresh.ToString());
    }

    public string DisplayName
    {
        get
        {
            string str = "";
            if (this.Width >= 0x3e8)
            {
                str = str + this.Width.ToString() + "   x  ";
            }
            else
            {
                str = str + "  " + this.Width.ToString() + "   x  ";
            }
            if (this.Height >= 0x3e8)
            {
                str = str + this.Height.ToString() + "  :  ";
            }
            else
            {
                str = str + " " + this.Height.ToString() + "   :  ";
            }
            return (str + this.Refresh.ToString());
        }
    }
}
